lighttmr = tmr.create()
steps = tmr.create()

switchOFF = function()
	print('Switch to OFF')
	steps:stop()
	dat.light = 'OFF'
	dat.brightnow = 0
	pwm.setduty(pinLight, 0)
end

light = function(wrt)
	if wrt == dat.light then return end
	dat.light = wrt
	local work
	local target =  wrt == 'ON' and dat.maxbrt or 0
	if dat.brightnow == 0 or dat.brightnow == dat.maxbrt then
		dat.brightnow = target == dat.maxbrt and 0 or dat.maxbrt
	end
	
	work = function()
		steps:alarm(dat.speed, 1, function(t)
			print('bright now = '..dat.brightnow)
			pwm.setduty(pinLight, dat.brightnow)
			dat.brightnow = wrt == 'ON' and (dat.brightnow + dat.step) or (dat.brightnow - dat.step)
			if dat.brightnow < 0 or dat.brightnow > dat.maxbrt then
				dat.brightnow = dat.brightnow > dat.maxbrt and dat.maxbrt or 0
				if dat.brightnow == 0 then switchOFF() end
				t:stop()
				t:unregister()
				t = nil
			end
		end)
	end
	return work()
end

lighttmr:register(lightTime, tmr.ALARM_SEMI, function() light('OFF') end)

pull = function()
	if dat.light == 'OFF' then light('ON') end
	lighttmr:stop()
	print('Pull!')
	lighttmr:start()
end
function analizepin(level )
	print('trig: ', level)
	if dat.secur == 'ON' then
		if level == 1 then
			table.insert(topub, {'bedroom', 'ON'})
			dofile 'mqttpub.lua'
		end
	else
		pull()
	end
end
gpio.trig(pinread01, 'both', analizepin)
gpio.trig(pinread02, 'both', analizepin)


